package MT::Plugin::SKR::OmitSearchStringFullWidthSpace;
########################################################################
#   OmitSearchStringFullWidthSpace
#           Copyright (c) SKYARC System Co.,Ltd.
########################################################################

use strict;
use MT;
use MT::App::Search;

use vars qw( $MYNAME $VERSION );
$MYNAME = 'OmitSearchStringFullWidthSpace';
$VERSION = '0.01';

use base qw( MT::Plugin );
my $plugin = __PACKAGE__->new({
        name => $MYNAME,
        id => lc $MYNAME,
        key => lc $MYNAME,
        version => $VERSION,
        author_name => 'SKYARC System Co.,Ltd.',
        author_link => 'http://www.skyarc.co.jp/',
#        doc_link => '',
        description => <<HTMLHEREDOC,
Omit the full-width spaces in search string
HTMLHEREDOC
});
MT->add_plugin( $plugin );



MT::App::Search->add_callback ('prepare_throttle', 9, $plugin, \&_hdlr_prepare_throttle);
sub _hdlr_prepare_throttle {
    my ($cb, $app) = @_;
    my $q = $app->{query}
        or return 1;
    my $search_string = $q->param('searchTerms') || $q->param('search')
        or return 1;
    # Get encoded full-width space
    my $charset = {'shift_jis'=>'sjis', 'iso-2022-jp'=>'jis', 'euc-jp'=>'euc', 'utf-8'=>'utf8'}->{lc $app->config->PublishCharset}
        or return 1;
    my $fullwidthspace = MT::I18N::encode_text ('　', 'utf8', $charset);
    # Replace full-width spaces into a half-width space
    $search_string =~ s/\Q$fullwidthspace\E/ /g;
    $search_string =~ s/\s+/ /g;
    # override the search string
    $q->param('searchTerms', $search_string);

    1;
}

1;